/***************************************************************************
 *   Copyright (C) 2009 by Mirko Lindner,,,   *
 *   vegyraupe@mira   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


// newer (non customized) versions of this file go to main_window.cc_new

// This file is for your program, I won't touch it again!

#include "config.h"
#include "main_window.hh"
#include "vido.hh"
#include <cxxtools/log.h>

// extern "C" {
// 	#include <directfb/directfb.h>
// 	#include <gtk-2.0/gdk/gdkdisplay-directfb.h>
// 	#include <gtk-2.0/gdk/gdkdirectfb.h>
// }

log_define("vido.main_window");

main_window::main_window()
{ 
	sigc::connection press_id;
	sigc::connection release_id;

}

void main_window::connect_all()
{
// 		(*this).add_events( Gdk::BUTTON_PRESS_MASK ) ;
		log_debug("connecting all");
// 		(*this).press_id = signal_key_press_event().connect(sigc::mem_fun(*this,&main_window::on_my_key_press_event));
//     (*this).release_id = signal_key_release_event().connect(sigc::mem_fun(*this,&main_window::on_my_key_release_event)); 
// 		(*this).press_id = 

		(*this).add_events (Gdk::ALL_EVENTS_MASK); 
		
		(*this).press_id = (*this).signal_key_press_event().connect_notify(sigc::mem_fun(*this,&main_window::on_notify_key_press_event));
    (*this).release_id = (*this).signal_key_release_event().connect_notify(sigc::mem_fun(*this,&main_window::on_notify_key_release_event));
// 		(*this).motion_id = (*this).signal_event().connect_notify(sigc::mem_fun(*this,&main_window::on_notify_motion_notify_event));
		log_debug((*this).press_id << " " << (*this).release_id);
		log_debug("event mask " << (*this).get_events());
}

void main_window::disconnect_all()
{
		log_debug("disconnecting all");
		(*this).press_id.disconnect();
    (*this).release_id.disconnect();
		log_debug((*this).press_id << " " << (*this).release_id);
}

void main_window::on_notify_motion_notify_event ( GdkEvent *event)
{
//   gdouble x, y;
//   gdouble pressure;
//   GdkModifierType state;
// 
//   if (event->is_hint)
//     gdk_input_window_get_pointer (event->window, event->deviceid,
//                                   &x, &y, &pressure, NULL, NULL, &state);
//   else
//     {
//       x = event->x;
//       y = event->y;
//       pressure = event->pressure;
//       state = event->state;
//     }
//     
//   if (state & GDK_BUTTON1_MASK && pixmap != NULL)
//     draw_brush (widget, event->source, x, y, pressure);
//   
	log_debug("event here " << event->type);
//   return TRUE;
}


void main_window::move_cursor(int direction){
	
		int x=0, y=0, xadd=0, yadd=0;
    Glib::RefPtr<Gdk::Display> display;
		display = display->get_default();
    Glib::RefPtr<Gdk::Screen> screen = display->get_default_screen();
// 		screen = display->get_default_screen();
   log_debug("display: " << display);
	 log_debug("screen: " << screen);
    /* check for up/down/left/right arrow key press */
		log_debug("moving " << direction);
    switch (direction)
    {
        case 65361:
            xadd -= 5;
            break;
        case 65363:
            xadd += 5;
            break;
        case 65362:
            yadd -= 5;
            break;
        case 65364:
            yadd += 5;
            break;   
        default:
						log_debug("unknown direction");
						break;
//             return FALSE; /* propogate event */
    }
   
    /* get default display and screen */
//     display = Gdk::Display::get_default();
// 		screen =Gdk::Display::get_default_screen();
//     screen = gdk_display_get_default_screen (display);
   
    /* get cursor position */
// 		GdkWindow* ; 
// 		IDirectFBWindow *gdk_directfb_window_lookup(gtk_widget_get_root_window(scrolled_window2));
// 		GdkDisplay gdk_display_open((const gchar) display->get_name());
		Gdk::ModifierType mask;
//     display->get_pointer(x, y, mask);
// 						log_debug("unknown direction 2");
   
    /* set new cusor position */
//     x += xadd;
//     y += yadd;
// 		IDirectFB *directfb;
// 		log_debug("unknown direction 3");
		
		
// 		GType _gdk_display = g_object_new (GDK_TYPE_DISPLAY_DFB, NULL);
// 		display->directfb = directfb;
		
// 		IDirectFBDisplayLayer *layer;
// 		int ret = directfb->GetDisplayLayer (directfb, DLID_PRIMARY, &layer);
// 						log_debug("unknown direction 4");
		
// 		int ret = directfb->GetDisplayLayer (directfb, DLID_PRIMARY, &layer);
		
		
// 		DFBResult result;
// 						log_debug("unknown direction 5");
// 
// 		result =  layer->WarpCursor(layer, x, y);
// 						log_debug("unknown direction 6");

// 		Gdk::ModifierType mask;
    display->get_pointer(x, y, mask);
// 		log_debug("pointer x: " << x << "pointer y: " << display->pointer_hooks);
    
//     display->warp_pointer( screen, x, y); 

// 		Gdk::Event event();
		 
// 		Gdk::Event event(gdk_event_new(GDK_MOTION_NOTIFY),true);
// 		
// // 		get_window_and_coordinates(event->button.window, event->button.x, event->button.y, event->button.x_root, event->button.y_root);
// 		event.send_event = TRUE;
// 		event.time = GDK_CURRENT_TIME;
// 		event.axes = 0;
// 		event.state = 0;
// 		event.motion.x = x;
// 		event.motion.y = y;
// 		/* set new cusor position */
    x += xadd;
    y += yadd;
// 		event.motion.x_root = x;
// 		event.motion.y_root = y;
// // 		event->button.button = Button;
// // 		event->button.device = gdk_device_get_core_pointer();
// 
// // 		g_object_ref(event->screen.window);
// 		event.put();
// 		handle_pending_events();
// 		gdk_event_free(event);
		Glib::RefPtr<Gdk::Device> pointer = display->get_core_pointer();
		log_debug("type cursor: " << pointer->get_source());
		log_debug("pointer xadd: " << xadd << "pointer yadd: " << yadd );
    if ((screen != 0) && (display!= 0)){
			display->warp_pointer( screen, x, y); 
// 			this->signal_motion_notify_event();
// 			g_signal_emit (G_OBJECT(display->gobj()), GDK_MOTION_NOTIFY, NULL, x= x, y = y);

		}
}

bool main_window::actions(int key)
{
// 		log_debug("in actions" << (*this).press_id << " " << (*this).release_id);
    static int key_b = 98;
    static int key_f = 102;
    static int key_h = 104;
    static int key_q = 113;
    static int key_r = 114;
    static int key_s = 115;
    static int key_t = 116;
		static int key_f1 = 65470;
		static int key_left = 65361;
		static int key_up = 65362;
		static int key_right = 65363;
		static int key_down = 65364;
		
		
		// key commands only available if ctrl pressed
		if ((ctrl_state == 1) && ((*this).press_id == 1))
		{
				(*this).disconnect_all();
				if (key == key_q)
				{
// 						log_debug("quit requested");
						(*this).quit();
				}
				else if(key == key_r)
				{
// 						log_debug("random");
						show_random();
				}
				else if(key == key_s)
				{
						log_debug("search");
						search_window(this);
				}else if(key == key_t){
						GoToTop();
				}else if(key == key_h){
						show_history();
				}else if(key == key_f){
						history_jump(1);
				}else if(key == key_b){
						history_jump(-1);
				}
				else{
					(*this).connect_all();
// 					log_debug("key pressed: " << key);
				}
		// other commands
		}else{
			if(key == key_f1){
				(*this).disconnect_all();
				show_help();
			}else if(key == 65361){
						log_debug("key is left");
						(*this).move_cursor(key);
				}else if(key == key_right){
						(*this).move_cursor(key);
				}else if(key == key_up){
						(*this).move_cursor(key);
				}else if(key == key_down){
						(*this).move_cursor(key);
				}
		}
		
		return true; 

}

void main_window::on_notify_key_press_event(GdkEventKey *Key) 
{ 
		
    if (Key->keyval == gdk_keyval_from_name("Control_R"))
    {
        ctrl_state = 1;
    }
    else
    {
			actions(Key->keyval);
    }
    log_debug("Key Presssed is " << Key->keyval); 
} 

void main_window::on_notify_key_release_event(GdkEventKey *Key) 
{ 
    if (Key->keyval == gdk_keyval_from_name("Control_R"))
    {
        ctrl_state = 0;
    }

} 

// bool main_window::on_my_key_press_event(GdkEventKey *Key) 
// { 
//     if (Key->keyval == gdk_keyval_from_name("Control_R"))
//     {
//         ctrl_state = 1;
//     }
//     else
//     {
// 			actions(Key->keyval);
//     }
//     log_debug("Key Presssed is " << Key->keyval); 
//     return true; 
// } 

// bool main_window::on_my_key_release_event(GdkEventKey *Key) 
// { 
//     if (Key->keyval == gdk_keyval_from_name("Control_R"))
//     {
//         ctrl_state = 0;
//     }
// 
//     return true; 
// } 

bool main_window::quit()
{  
    (*this).destroy_();
    return false;
}
